using System;
namespace CSDesingPattern
{	
	public class XBox
	{
		private GameBox mGameBox=null;
		private InternetBox mInternetBox=null;

		public XBox()
		{
			mGameBox = new GameBox();
			mInternetBox = new InternetBox();
		}
		public void PlayGame()
		{
			mGameBox.PlayGame();
		}
		public void ConnectToInternet()
		{
			mInternetBox.ConnectToInternet();
		}
		public void GetMail()
		{
			mInternetBox.GetMail();
		}		
	}
	public class GameBox
	{
		public void PlayGame()
		{
			Console.WriteLine("һϷ");
		}

	}
	public class InternetBox
	{
		
		public void ConnectToInternet()
		{			
			Console.WriteLine("ӵInternet~");			
		}
		public void GetMail()
		{			
			Console.WriteLine("ʼ");
		}
	}
	public class CSComposite
	{
		static void Main(string[] args)
		{
			XBox x = new XBox();
			Console.WriteLine("PlayGame!");
			x.PlayGame();
			Console.WriteLine();

			Console.WriteLine("Internet Play Game!");	
			x.ConnectToInternet();
			x.PlayGame();
			Console.WriteLine();

			Console.WriteLine("E-Mail!");
			x.GetMail();
		}		
	}
}
